image: docker:latest

services:
  - docker:dind

variables:
  CI_REGISTRY_IMAGE_CRONJOBS: "$CI_REGISTRY/odai.work4all/package-registry-project/cronjobs:latest"
  OLD_AUTOSCALER: "k8s.gcr.io/autoscaling/cluster-autoscaler:v1.26.0"
  OLD_ATTACHER: "registry.k8s.io/sig-storage/csi-attacher:v4.1.0"
  OLD_PROVISIONER: "registry.k8s.io/sig-storage/csi-provisioner:v3.4.0"
  OLD_RESIZER: "registry.k8s.io/sig-storage/csi-resizer:v1.7.0"
  OLD_LIVENESSPROBE: "registry.k8s.io/sig-storage/livenessprobe:v2.9.0"
  OLD_REGISTRAR: "registry.k8s.io/sig-storage/csi-node-driver-registrar:v2.7.0"
  NEW_AUTOSCALER: "$CI_REGISTRY/odai.work4all/package-registry-project/cluster-autoscaler:v1.26.0"
  NEW_ATTACHER: "$CI_REGISTRY/odai.work4all/package-registry-project/csi-attacher:v4.1.0"
  NEW_PROVISIONER: "$CI_REGISTRY/odai.work4all/package-registry-project/csi-provisioner:v3.4.0"
  NEW_RESIZER: "$CI_REGISTRY/odai.work4all/package-registry-project/csi-resizer:v1.7.0"
  NEW_LIVENESSPROBE: "$CI_REGISTRY/odai.work4all/package-registry-project/livenessprobe:v2.9.0"
  NEW_REGISTRAR: "$CI_REGISTRY/odai.work4all/package-registry-project/csi-node-driver-registrar:v2.7.0"
  TF_TEST: ${CI_PROJECT_DIR}/test
  TF_EXAMPLES: ${CI_PROJECT_DIR}/examples
  TERRAFORM_BINARY_VERSION: "1.2.7"
  SCRIPTS_FOLDER: ${CI_PROJECT_DIR}/scripts
  ACCESS_TOKEN: $ACCESS_TOKEN
  TF_USERNAME: $GITLAB_USERNAME



stages:
  - push
  - validate
  - build
  - test
  - release

.push:
  stage: push
  script:
    - echo $CI_REGISTRY_IMAGE_CRONJOBS
    - echo $CI_REGISTRY_USER
    - echo $CI_REGISTRY_PASSWORD
    - echo $CI_REGISTRY
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $OLD_AUTOSCALER
    - docker pull $OLD_ATTACHER
    - docker pull $OLD_PROVISIONER
    - docker pull $OLD_RESIZER
    - docker pull $OLD_LIVENESSPROBE
    - docker pull $OLD_REGISTRAR
    - docker tag $OLD_AUTOSCALER $NEW_AUTOSCALER
    - docker tag $OLD_ATTACHER $NEW_ATTACHER
    - docker tag $OLD_PROVISIONER $NEW_PROVISIONER
    - docker tag $OLD_RESIZER $NEW_RESIZER
    - docker tag $OLD_LIVENESSPROBE $NEW_LIVENESSPROBE
    - docker tag $OLD_REGISTRAR $NEW_REGISTRAR
    - docker push $NEW_AUTOSCALER
    - docker push $NEW_ATTACHER
    - docker push $NEW_PROVISIONER
    - docker push $NEW_RESIZER
    - docker push $NEW_LIVENESSPROBE
    - docker push $NEW_REGISTRAR


#- docker build -t $CI_REGISTRY_IMAGE_CRONJOBS ./cronjobs-image
#- docker push $CI_REGISTRY_IMAGE_CRONJOBS


.initialize: &init
  before_script:
    - cd ${TF_EXAMPLES}
    - terraform init -backend-config="username=${TF_USERNAME}" -backend-config="password=${ACCESS_TOKEN}"

validate:
  stage: validate
  rules:
    - if: '$CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "main"'
      when: always
  script:
    - ${SCRIPTS_FOLDER}/validate.sh
    - terraform init
    - terraform validate

plan:
  stage: build
  rules:
    - if: '$CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "main"'
      when: on_success
    - when: never
  script:
    - terraform plan
  artifacts:
    name: plan
    paths:
      - ${TF_EXAMPLES}/plan.cache

test:
  stage: test
  rules:
    - if: '$CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "main"'
      when: on_success
    - when: never
  script:
    - cd ${TF_TEST}
    #- go test -v -timeout 30m

.semantic-release:
  image: node:18-buster-slim
  stage: release
  before_script:
    - apt-get update && apt-get install -y --no-install-recommends git-core ca-certificates
    - npm install -g semantic-release @semantic-release/commit-analyzer @semantic-release/gitlab @semantic-release/changelog @semantic-release/release-notes-generator @semantic-release/git
  script:
    - semantic-release $DRY_RUN_OPT -b $CI_COMMIT_REF_NAME

tag_release_dryrun:
  extends:
    - .semantic-release
  rules:
    - if: '$CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "main"'
      when: on_success
    - when: never

tag_release:
  extends: .semantic-release
  only:
    - main
  when: manual
